

#include "sjis_unicode.h"

#include <stdio.h>
#include <stdlib.h>
#include <time.h>
#include <string.h>


unsigned long htoul(const char* str);

static unsigned short*	sutable;
static unsigned short*	ustable;


void sjis_unicode_setup()
{
	FILE*			file = fopen("JIS0208", "rt");
	char			string[256];
	char			sjis_char[14], jis_char[14], unicode_char[14];
	unsigned short	sjis, jis, unicode;

	sutable = (unsigned short*) malloc(65536 * sizeof(unsigned short));
	ustable = (unsigned short*) malloc(65536 * sizeof(unsigned short));

	for (long i = 0; i < 256; i++) {
		sutable[i] = i;
		ustable[i] = i;
	}
	for (long i = 256; i < 65536; i++) {
		sutable[i] = 0xFFFF;
		ustable[i] = 0xFFFF;
	}


	while (fgets(string, 256, file)) {
		if (string[0] == '#')
			continue;
		sscanf(string, "0x%s\t0x%s\t0x%s", sjis_char, jis_char, unicode_char);
		sjis = htoul(sjis_char);
		unicode = htoul(unicode_char);
		sutable[sjis] = unicode;
		ustable[unicode] = sjis;
	}

	fclose(file);
}

unsigned long htoul(const char* str)
{
	unsigned long	value = 0;
	while (*str) {
		value *= 16;
		if (*str <= '9')
			value += *str - '0';
		else
			value += *str - 'A' + 10;
		str++;
	}
	return value;
}

unsigned short sjis_to_unicode(unsigned short sjis)
{
	return sutable[sjis];
}

unsigned short unicode_to_sjis(unsigned short unicode)
{
	return ustable[unicode];
}


